\ META.F

\ A crude Meta Compiler to build the Enth kernel. Run successfully in
\ Swiftforth 2.00.3 and Win32forth 4.2. Implements some optimization inlining
\ some code words and control structures.

HEX ONLY FORTH DEFINITIONS VOCABULARY META ALSO META DEFINITIONS

: ;THEN ( ORIG - ) POSTPONE EXIT POSTPONE THEN ; IMMEDIATE

: TALIGNED  ( N - N' ) 1- 4 2DUP MOD - + ;

30000 ALLOCATE DROP TALIGNED VALUE FSPACE

10000 VALUE TORIGIN

VARIABLE A
: A! A ! ;
: A@ A @ ;
: !A A @ ! ;
: @A A @ @ ;
: !A+ A @ ! 4 A +! ;
: @A+ A @ @ 4 A +! ;

FSPACE TORIGIN + VALUE TSPACE
TSPACE 8000 + VALUE HSPACE

TSPACE VALUE THERE
HSPACE VALUE HHERE
VARIABLE ENTHLINK 0 ENTHLINK !
VARIABLE HIDELINK 0 HIDELINK !

VARIABLE INLINEABLE

: TSWAP     ( - ) THERE HHERE TO THERE TO HHERE TSPACE HSPACE TO TSPACE TO HSPACE ;
: TALLOT    ( N - ) +TO THERE ;
: TC,       ( N - ) THERE 1 TALLOT C! ;
: T,        ( N - ) THERE 4 TALLOT  ! ;
: TNOPS      ( N - ) DUP IF 0 DO 90 TC, LOOP EXIT THEN DROP ;
: TALIGN-1   ( - ) THERE DUP TALIGNED SWAP - DUP IF 1- TNOPS ELSE DROP 3 TNOPS THEN ;
: TALIGN    ( - ) THERE DUP TALIGNED SWAP - TNOPS ;
: TLINK,    ( - ) ENTHLINK @ T, THERE FSPACE - ENTHLINK ! ;
: >UC       ( A - ) DUP C@ DUP 61 7B WITHIN IF 20 - SWAP C! ;THEN 2DROP ;
: >UCASE    ( CA - CA ) DUP DUP C@ 0 DO DUP I + 1+ >UC LOOP DROP ;
: TNAME,    ( - ) BL WORD >UCASE DUP C@ 1+ THERE SWAP DUP TALLOT CMOVE TALIGN ;
: TPREC,    ( - ) 0 TC, ;
: THEADER,  ( - ) THERE FSPACE - TSWAP TALIGN-1 TPREC, TLINK, TNAME, T, TSWAP ;
: TNFA>CFA  ( N - ) DUP C@ 1+ TALIGNED + @ ;
: TNFA>PFA  ( A - A' ) CELL- 1- ;
: EQU       ( N - ) VALUE ;
: PLACE     ( CA CA2 U2 - ) >R SWAP R@ OVER C! 1+ R> CMOVE ;
: APPEND    ( CA CA2 U2 - ) 2 PICK DUP C@ SWAP 1+ + SWAP DUP >R CMOVE R> OVER C@ + SWAP C! ;
: TCOMPILE, ( A - ) E8 TC, THERE CELL+ - T, ;

VARIABLE TSTATE 0 TSTATE !

: TARGET-VERSION ( - ) CREATE , DOES> @ ;

CREATE CODEBUFFER 100 ALLOT

: TARGET-LABEL ( - )
        CODEBUFFER S" TARGET-VERSION " PLACE
        CODEBUFFER ENTHLINK @ FSPACE + COUNT APPEND
        THERE CODEBUFFER COUNT EVALUATE
        ENTHLINK @ FSPACE + COUNT CR TYPE ;

: .STACK ( - ) CR ." SYS-STACK:  " DEPTH . ;



ALSO SASM

: CODE     ( - ) THEADER, TARGET-LABEL ASM: ;
: ICODE    ( - ) THERE INLINEABLE ! CODE ;
: C;       ( - ) ASM; ;
: END-CODE ( - )
        INLINEABLE @
        IF      ENTHLINK @ FSPACE + TNFA>PFA DUP C@
                THERE 1- INLINEABLE @ - OR SWAP C!
                FALSE INLINEABLE !
        THEN    ASM; .STACK ;

: T: ( - ) THEADER, TARGET-LABEL TRUE TSTATE ! ;
: (T;) ( - ) FALSE TSTATE ! CR ." SYS-STACK:  " DEPTH . ;
: T; ( - ) C3 TC, (T;) ;
: TT; ( - ) E9 THERE 5 - C! (T;) ;

PREVIOUS

0 VALUE FILEID

: WRITE-BINARY ( CA U - )
        R/W CREATE-FILE DROP TO FILEID
        TSPACE FA00 FILEID WRITE-FILE DROP
        FILEID CLOSE-FILE DROP ;

: TCAST ( - A ) THERE 04 TALLOT ;
: TSNAG ( A - ) THERE OVER - SWAP ! ;
: TBITE ( A - A' ) TCAST SWAP TSNAG ;
: THOOK ( A - ) THERE - T, ;

: <SNAG> ( A - ) THERE OVER - SWAP ! ;

: <IF> ( - ORIG ) 0FADC009 T, 84 TC, ;
: <ELSE> ( ORIG - ORIG2 ) E9 TC, ;
: <THEN> ( ORIG - ) THERE OVER - CELL- SWAP ! ;
: <MARK> ( - ORIG ) THERE 4 TALLOT ;
: <RESOLVE> ( DEST - ) THERE CELL+ - T, ;

: TLITERAL ( N - ) 83 TC, EE TC, 04 TC, 89 TC, 06 TC, B8 TC, T, ;

: { ALSO FORTH ;
: } PREVIOUS ;

HEX ONLY FORTH DEFINITIONS ALSO SASM ALSO META DEFINITIONS

WORDLIST VALUE IHOSTX
WORDLIST VALUE EHOSTX
WORDLIST VALUE OHOSTX
WORDLIST VALUE ENTHX

: ENTH  ( - ) GET-ORDER >R DROP ENTHX  R> SET-ORDER ;
: EHOST ( - ) GET-ORDER >R DROP EHOSTX R> SET-ORDER ;
: IHOST ( - ) GET-ORDER >R DROP IHOSTX R> SET-ORDER ;
: OHOST ( - ) GET-ORDER >R DROP OHOSTX R> SET-ORDER ;

' THERE IS SHERE
' TALLOT IS SALLOT

: .MS TSPACE 100 DUMP ;

ALSO EASM

: PUSHD ( - ) SUB SP 4 # MOV 0 [SP] T ;
: POPD ( - ) LODSD ;

: TCB-VAR ( N - ) CODE   SUB SP 4 #   MOV 0 [SP] T   MOV T UP   ADD T #   RET END-CODE ;

PREVIOUS

DECIMAL

: hide noop ;

00
dup constant tcb>actlink  hide cell+    \ Active Tasks Ring Link Field
dup constant tcb>nfa      hide cell+    \ Task Name Field Address
dup constant tcb>base     hide cell+    \ Numeric Radix
dup constant tcb>sp       hide 260 +    \ Parameter Stack Pointer
dup constant tcb>sp0      hide 8   +    \ Parameter Stack Base
dup constant tcb>rp       hide 260 +    \ Return Stack Pointer
dup constant tcb>rp0      hide 8   +    \ Return Stack Base
dup constant tcb>hand     hide cell+    \ Error Handler
dup constant tcb>areg     hide cell+    \ Address Register
dup constant tcb>dp       hide cell+    \ Dictionary Pointer
dup constant tcb>dp0      hide cell+    \ Dictionary Base
dup constant tcb>hp       hide cell+    \ Header Pointer
dup constant tcb>hp0      hide cell+    \ Header Base
dup constant tcb>root     hide cell+    \ Forth Wordlist
dup constant tcb>flux     hide cell+    \ Flux Wordlist
dup constant tcb>macro    hide cell+    \ Macro Wordlist
dup constant tcb>state    hide cell+    \ Compiler State
dup constant tcb>blk      hide cell+    \ Block
dup constant tcb>sblk     hide cell+    \ Superblock Address
dup constant tcb>tib      hide cell+    \ Source Buffer
dup constant tcb>#tib     hide cell+    \ Source Buffer Length
dup constant tcb>in       hide cell+    \ Source Pointer
dup constant tcb>sid      hide cell+    \ Source ID
dup constant tcb>hist     hide cell+    \ History
dup constant tcb>hld      hide 40  +    \ Hold Pointer & Number Conversion Buffer (36 bytes)
dup constant tcb>spad     hide 256 +    \ Source String Buffer (256 bytes)
dup constant tcb>current  hide cell+    \ Definitions Wordlist
dup constant tcb>search   hide cell+    \ Search Length
dup constant tcb>swb      hide 64  +    \ Search Order (64 bytes = 16 wordlists)
dup constant tcb>focus    hide cell+    \ Terminal Focus
dup constant tcb>mark     hide cell+    \ Dictionary Marker
drop

HEX

ONLY FORTH ALSO META DEFINITIONS

VARIABLE LAST

CREATE NOW 100 ALLOT

: NEXTWORD ( - )
        BL WORD DUP C@ 0=
        IF      DROP REFILL DROP BL WORD
        THEN    >UCASE COUNT NOW 2DUP C! 1+ SWAP CMOVE ;

: SIGN ( CA U - CA U M ) OVER C@ 2D = IF 1- >R 1+ R> -1 ELSE 1 THEN ;

: TINTERPRET ( - )
        BEGIN   NEXTWORD NOW COUNT IHOSTX SEARCH-WORDLIST
                IF      EXECUTE
                ELSE    NOW COUNT OHOSTX SEARCH-WORDLIST
                        IF      EXECUTE
                        ELSE    NOW COUNT ENTHX SEARCH-WORDLIST
                                IF      EXECUTE TCOMPILE,
                                ELSE    0 0 NOW COUNT SIGN >R >NUMBER 0=
                                        IF      DROP D>S R> * TLITERAL
                                        ELSE    NOW COUNT TYPE ."  - WHAT?" ABORT
                                        THEN
                                THEN
                        THEN
                THEN
        CR NOW COUNT TYPE .STACK TSTATE @ 0=
        UNTIL ;

: META-ORDER ONLY FORTH ALSO SASM ALSO META ALSO EHOST ALSO ENTH DEFINITIONS PREVIOUS ;

: TCOMPILE ( - ) ONLY ENTH EVALUATE TCOMPILE, META-ORDER ;

: T' ( - A ) BL WORD COUNT ENTHX SEARCH-WORDLIST IF EXECUTE FSPACE - THEN ;

: TCREATE ( - )
        TALIGN-1 T: S" VAR" TCOMPILE
        ONLY META ALSO ENTH ALSO EHOST DEFINITIONS
        CODEBUFFER S" TARGET-VERSION " PLACE
        CODEBUFFER ENTHLINK @ FSPACE + COUNT APPEND
        THERE FSPACE - CODEBUFFER COUNT EVALUATE META-ORDER (T;) ;

: TS' ( - ) S" (S')" TCOMPILE [CHAR] " WORD DUP C@ 1+ THERE SWAP DUP TALLOT CMOVE ;

: DROP,  AD TC, ;
: DUP,   83 TC, EE TC, 04 TC, 89 TC, 06 TC, ;
: NIP,   83 TC, C6 TC, 04 TC, ;

ALSO OHOST DEFINITIONS PREVIOUS

: 1+    40 TC, ;
: 1-    48 TC, ;
: DROP  DROP, ;
: DUP   DUP, ;
: SWAP  068BC289 T, 89 TC, 16 TC, ;
: @     8B TC, 00 TC, ;
: A!    89 TC, C7 TC, DROP, ;
: A@    DUP, 89 TC, F8 TC, ;
: !     1089168B T, DROP, DROP, ;
: C@    8AC03193 T, 03 TC, ;
: C!    1088168B T, DROP, DROP, ;
: +!    1001168B T, DROP, DROP, ;
: *     91 TC, DROP, F7 TC, E1 TC, ;
: PUSH  50 TC, DROP, ;
: POP   DUP, 58 TC, ;
: >R    50 TC, DROP, ;
: R>    DUP, 58 TC, ;
: +     03 TC, 06 TC, NIP, ;
: -     29 TC, 06 TC, DROP, ;
: CELL- 2D TC, 4 T, ;
: CELL+ 05 TC, 4 T, ;

ALSO EHOST DEFINITIONS PREVIOUS

ALSO SASM
: ASM: ( - ) ASM: ;
: ASM; ( - ) ASM; ;
: CALL: ( A - ) ASM; NEXTWORD NOW COUNT TCOMPILE ASM: ;

PREVIOUS

: ALLOT     ( N - ) TALLOT ;
: HERE      ( - A ) THERE FSPACE - ;
: ,         ( N - ) T, ;
: C,        ( C - ) TC, ;
: !         ( N A - ) FSPACE + ! ;
: @         ( A - N ) FSPACE + @ ;
: C!        ( C A - ) FSPACE + C! ;
: C@        ( A - C ) FSPACE + C@ ;
: +         ( N N2 - N3 ) + ;
: -         ( N N2 - N3 ) - ;
: CELLS     ( N - N' ) 2* 2* ;
: CONSTANT  ( N - ) T: S" VAL" TCOMPILE T, (T;) ;
: VALUE     ( N - ) T: S" VAL" TCOMPILE T, (T;) ;
: VAR       ( - ) T: S" VAR" TCOMPILE (T;) ;
: DEFER     ( - ) T: S" NOOP" TCOMPILE TT; ;
: IMMEDIATE ( - ) ENTHLINK @ FSPACE + 1- CELL- DUP C@ 80 OR SWAP C! ;
: CREATE    ( - ) TCREATE ;
: VARIABLE  ( - ) TCREATE 0 T, ;
: '         ( - XT ) T' ;
: ]         ( - ) TRUE TSTATE ! TINTERPRET META-ORDER ;
: .(        ( - ) .( ;
: HEX       ( - ) HEX ;
: DECIMAL   ( - ) DECIMAL ;
: BINARY    ( - ) BINARY ;
: TO        ( N - ) T' TSTATE @ IF 1+ CELL+ TLITERAL S" !" TCOMPILE ELSE FSPACE + 1+ CELL+ ! THEN ;
: +TO       ( N - ) T' TSTATE @ IF 1+ CELL+ TLITERAL S" +!" TCOMPILE ELSE FSPACE + 1+ CELL+ +! THEN ;
: IS        ( A - ) T' FSPACE + SWAP FSPACE + SWAP 1+ TUCK CELL+ - SWAP ! ;
: HIDE      ( - ) ENTHLINK @ FSPACE + CELL- DUP @ ENTHLINK ! HIDELINK @ OVER ! CELL+ FSPACE - HIDELINK ! ;
: INLINE    ( - ) ENTHLINK @ FSPACE + 1- CELL- DUP C@ 7E OR SWAP C! ;
: USER      ( n - ) TCB-VAR ;
: CELL+     ( n - n' ) 4 + ;
: CELL-     ( n - n' ) 4 - ;
: DUP       ( n - n n ) DUP ;
: DROP      ( n - ) DROP ;
: LATEST    ( - a ) ENTHLINK FSPACE - ;

: :         ( - ) T: TINTERPRET META-ORDER ;

ALSO IHOST DEFINITIONS PREVIOUS

: IF      ( - ORIG ) <IF> <MARK> ;
: THEN    ( ORIG - ) <THEN> ;
: ELSE    ( ORIG - ORIG2 ) <ELSE> <MARK> SWAP <THEN> ;
: EXIT    ( - ) C3 TC, ;
: ;THEN   ( - ) C3 TC, <THEN> ;
: EXIT?   ( - ) <IF> <MARK> C3 TC, <THEN> ;
: LEAVE?  ( - ) <IF> <MARK> S" LEAVE" TCOMPILE <THEN> ;
: BEGIN   ( - DEST ) THERE ;
: UNTIL   ( DEST - ) <IF> <RESOLVE> ;
: AGAIN   ( DEST - ) <ELSE> <RESOLVE> ;
: WHILE   ( DEST - ORIG DEST ) <IF> <MARK> SWAP ;
: REPEAT  ( ORIG DEST - ) <ELSE> <RESOLVE> <THEN> ;
: NEXT    ( DEST - ) 48 TC, 0F TC, 85 TC, <RESOLVE> AD TC, ;
: CASE    ( - CASE-SYS ) FALSE ;
: OF      ( - OF-SYS ) S" (OF)" TCOMPILE <MARK> ;
: ENDOF   ( CASE-SYS OF-SYS - CASE-SYS2 ) S" (JMP)" TCOMPILE <MARK> SWAP <SNAG> SWAP 1+ ;
: ENDCASE ( CASE-SYS - ) S" DROP" TCOMPILE 0 ?DO <SNAG> LOOP ;
: DO      ( - ORIG ORIG2 ) S" (DO)" TCOMPILE TCAST THERE ;
: ?DO     ( - ORIG ORIG2 ) S" (?DO)" TCOMPILE TCAST THERE ;
: LOOP    ( ORIG ORIG2 - ) S" (LOOP)" TCOMPILE THOOK TSNAG ;
: +LOOP   ( ORIG ORIG2 - ) S" (+LOOP)" TCOMPILE THOOK TSNAG ;
: [']     ( - ) T' TLITERAL ;
: TO      ( N - ) T' TSTATE @ IF 1+ CELL+ TLITERAL S" !" TCOMPILE ELSE FSPACE + 1+ CELL+ ! THEN ;
: +TO     ( N - ) T' TSTATE @ IF 1+ CELL+ TLITERAL S" +!" TCOMPILE ELSE FSPACE + 1+ CELL+ +! THEN ;
: IS      ( A - ) T' S" (IS)" TCOMPILE T, ;
: DOES>   ( - ) S" (DOES>)" TCOMPILE S" POP" TCOMPILE ;
: LITERAL ( - ) TLITERAL ;
: S"      ( - ) TS' ;
: ."      ( - ) TS' S" TYPE" TCOMPILE ;
: [       ( - ) FALSE TSTATE ! META-ORDER ;
: [CHAR]  ( - C ) CHAR TLITERAL ;
: (       ( - ) POSTPONE ( ;
: \       ( - ) POSTPONE \ ;
: ;       ( - ) T; ;

: POSTPONE ( - )
        NEXTWORD NOW COUNT IHOSTX SEARCH-WORDLIST
        IF      DROP NOW COUNT ENTHX SEARCH-WORDLIST
                IF      EXECUTE TCOMPILE,
                ELSE    NOW COUNT TYPE ."  - WHAT?" ABORT
                THEN
        ELSE    NOW COUNT ENTHX SEARCH-WORDLIST
                IF      EXECUTE FSPACE - TLITERAL S" COMPILE," TCOMPILE
                ELSE    NOW COUNT TYPE ."  - WHAT?" ABORT
                THEN
        THEN    ;


META-ORDER

